<template>
  <Line :data="data" :options="options" />
</template>

<script setup lang="ts">
import {
  Chart as ChartJS,
  CategoryScale,
  LinearScale,
  PointElement,
  LineElement,
  Title,
  Tooltip,
  Legend,
} from "chart.js";
import { Line } from "vue-chartjs";
import type { ChartData, ChartOptions } from "chart.js";
import { ref, type PropType, onMounted } from "vue";

import { updateData, updateOptions } from "./index";

ChartJS.register(CategoryScale, LinearScale, PointElement, LineElement, Title, Tooltip, Legend);

const props = defineProps({
  label: { type: String, required: true },
  labels: { type: Array as PropType<string[]>, required: true },
  backgroundColor: { type: String, required: true },
  data: { type: Array as PropType<number[]>, required: true },
});

const data = ref<ChartData<"line">>({ datasets: [] });

const options = ref<ChartOptions<"line">>({
  responsive: true,
  maintainAspectRatio: false,
});

onMounted(() => {
  updateData(props.label, ["0"], props.backgroundColor, []);
  updateOptions();
  setInterval(() => {
    data.value = updateData(props.label, props.labels, props.backgroundColor, props.data);
  }, 3000);
});
</script>

<style scoped></style>
